const key_esc%     =key_escape
const key_capslock%=20

appdir=addslash(convertchar(appdir,asc"/",asc"\"))
appfile=convertchar(appfile,asc"/",asc"\")
for local a%=0 until appargs.length
  if (appargs[a][appargs[a].length-2..]=":"+chr(34))..
  then appargs[a]=appargs[a][..appargs[a].length-1]+"\"..
  else appargs[a]=convertchar(appargs[a],asc"/",asc"\")
next

function between$(src$,pos%=1,ch%=asc"\")
  local sl%
  local st%
  while (sl<src.length)
    if (src[sl]=ch) then
      pos:-1
      if (pos<=0) then return src[st..sl]'+1]
      st=sl+1
    endif
    sl:+1
  wend
'  if (pos=1) then return src[st..]
  return src[st..]
endfunction

function delead$(src$,ch%=asc" ")
  local a%,sl%=src.length
  while (a<sl) and (src[a]=ch)
    a:+1
  wend
  return src[a..]
endfunction

function delast$(src$,ch%=asc"\")
  local sl%=src.length-1
  while (sl>=0) and (src[sl]=ch)
    sl:-1
  wend
  return src[..sl+1]
endfunction

function deleast$(src$,ch%=asc" ")
  local a%,sl%=src.length
  while (a<sl) and (src[a]=ch)
    a:+1
  wend

  sl:-1
  while (sl>=0) and (src[sl]=ch)
    sl:-1
  wend
  return src[a..sl+1]
endfunction

function convertchar$(src$,ch1%,ch2%)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=ch1) then src=src[..sl]+chr(ch2)+src[sl+1..]
  wend
  return src
endfunction

function convertlstr$(src$,ch1$,ch2$)
  local cl1%=ch1.length
  if (cl1=0) then return src
  local pos%=src.length
  pos:-cl1
  while (pos>=0)
'    if (lower(src[pos..pos+cl1])=ch1) then src=src[..pos]+ch2+src[pos+cl1..]
    local b%
    while (b<cl1)
      local v%=src[pos+b]
      if (v>=asc"A") and (v<=asc"Z") then v:+(asc"a"-asc"A")
      if (v<>ch1[b]) then exit
      b:+1
    wend
    if (b=cl1) then src=src[..pos]+ch2+src[pos+cl1..]
    pos:-1
  wend
  return src
endfunction

function charmul$(ch$,mul%)
  if not mul then return ""
  local a%=1
  while (a+a<mul)
    ch:+ch
    a:+a
  wend
  return ch+ch[..mul-a]
endfunction

function findcharpos%(src$,ch%,nr%=1)
  if (nr=0) then return 0
  local sl%
  while (sl<src.length)
    if (src[sl]=ch) then
      nr:-1
      if (nr=0) then return sl+1
    endif
    sl:+1
  wend
  return sl
endfunction

function zeroed$(src$,ch$="0",mul%)
'  mul:-src.length
'  return charmul(ch,mul)+src
  mul:-src.length
  if (mul<=0) then return src
  local a%=1
  while (a+a<mul)
    ch:+ch
    a:+a
  wend
  return ch+ch[..mul-a]+src
endfunction

'b=^n($1,$2,$4...)
function swapbit%(src%,b%)
  return (src&~b) + (b-(src&b))
endfunction

'-----------------------------------------

function readcomment$(f:tstream,linecom%=asc";")
  local t$
  repeat
    if eof(f) then return ""
    t=readline(f)
  until (t<>"") and (delead(t)[0]<>linecom)
  return t
endfunction

function readstr$(f:tstream)
  return readstring(f,readpint(f))
endfunction
function writestr(f:tstream,s$)
  writepint f,s.length
  writestring f,s
endfunction

function readpint%(f:tstream)
  local ret%,a%,c%
  repeat
    a=readbyte(f)
    ret:+(a&$7f) shl c
    c:+7
  until not(a&$80)
  return ret
endfunction
function writepint(f:tstream,src%)
  repeat
    writebyte f,(src&$7f) + ((src shr 7<>0) shl 7)
    src:shr 7
  until not src
endfunction

function addslash$(src$,sl%=asc"\")
  if src.length and (src[src.length-1]<>sl) then return src+chr(sl)
  return src
endfunction

'c:\path1.a\path2.b\file.test = c:\path1.a\path2.b\
function trimpath$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[..sl+1]
  wend
  return src[..sl]
endfunction

'c:\path1.a\path2.b\file.test = file
function trimname$(src$,hidext%=false)
  local sl1%=src.length
  local sl2%=sl1
  local l%=true
  while (sl1>0)
    sl1:-1
    if (l or hidext) and (src[sl1]=asc".") then
      sl2=sl1
      l=false
    endif
    if (src[sl1]=asc"\") then return src[sl1+1..sl2]
  wend
  return src[sl1..sl2]
endfunction

'c:\path1.a\path2.b\file.test = test
function trimext$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc".") then return src[sl+1..]
    if (src[sl]=asc"\") then return ""
  wend
endfunction

'c:\path1.a\path2.b\file.test = file.test
function trimfile$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[sl+1..]
  wend
  return src
endfunction

'c:\path1.a\path2.b\file.test = c:\path1.a\path2.b\file
function trimpname$(src$,hidext%=false)
  local sl%=src.length
  local sl2%=src.length
  local l%=true
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[..sl2]
'    if (src[sl]=asc".") then return src[..sl]
    if (l or hidext) and (src[sl]=asc".") then
      sl2=sl
      l=false
    endif
  wend
  return src[..sl2]
endfunction

'c:\path1.a\path2.b\file.test = path2.b\
function trimpathf$(src$)
  local sl1%=src.length-1
  while (sl1>=0) and (src[sl1]<>asc"\")
    sl1:-1
  wend
  local sl2%=sl1+1
  while (sl1>0)
    sl1:-1
    if (src[sl1]=asc"\") then return src[sl1+1..sl2]
  wend
  return src[..sl2]
endfunction

'-----------------------------------------

private
extern "Win32"
  function GetLocalTime(apitime:byte ptr)

  const SPI_GETWORKAREA%=48
  function SystemParametersInfoA%(action%,param%,param2:byte ptr,winini%)
endextern
public

function getdesktoparea(lpRect%[])
	SystemParametersInfoA(SPI_GETWORKAREA,0,lpRect,0)
endfunction

private
type tapitime
  field Year:short
  field Month:short
  field DayOfWeek:short
  field Day:short
  field Hour:short
  field Minute:short
  field Second:short
  field Milliseconds:short
endtype
public

incbin "ytbl.bin"
global days$[]=["So","Mo","Di","Mi","Do","Fr","Sa"]
const maxytbl%=28
const aweek%=7

const _hour%=0
const _min%=1
const _sec%=2
const _year%=0
const _mon%=1
const _day%=2

function calcday%(src%[],srcpos%=0)
  return (byte ptr(incbinptr("ytbl.bin"))[src[srcpos+_year] mod maxytbl*12 + src[srcpos+_mon]-1] + src[srcpos+_day]-1) mod aweek
endfunction
function getdatetime(dst%[])
  local ap:tapitime=new tapitime
  getlocaltime ap
  dst[_year]=ap.year
  dst[_mon]=ap.month
  dst[_day]=ap.day
  dst[3+_hour]=ap.hour
  dst[3+_min]=ap.minute
  dst[3+_sec]=ap.second
endfunction

function datetime2str$(src%[],srcpos%=0)
  return zeroed(src[srcpos+3+_hour],"0",2)+":"..
        +zeroed(src[srcpos+3+_min] ,"0",2)+":"..
        +zeroed(src[srcpos+3+_sec] ,"0",2)+", "..
        +zeroed(src[srcpos+_day]   ,"0",2)+"."..
        +zeroed(src[srcpos+_mon]   ,"0",2)+"."..
        +src[srcpos+_year]
endfunction

'------------------------------------------

global actwin:twin=null
global desk%[4]
getdesktoparea desk

function setlayout(g:tgadget,xw%,yh%,grp:tgadget,lft%=1,up%=1)
  local x2%,y2%
  if (xw=clientwidth (grp)) then x2=1
  if (yh=clientheight(grp)) then y2=1
'  if (xw=gadgetwidth (grp)) then x2=1
'  if (yh=gadgetheight(grp)) then y2=1
  setgadgetlayout g,lft,x2,up,y2
endfunction

function createwline:tgadget(x%,y%,w%,grp:tgadget,hsz%=1,style%=label_sunkenframe)
  local g:tgadget=createlabel("",x,y,w,hsz+(style=label_frame),grp,style)
  setlayout g,x+w,y,grp
  return g
endfunction

function createlab:tgadget(name$,x%,y%,w%,h%,grp:tgadget,style%=0)
  local g:tgadget=createlabel(name,x,y,w,h,grp,style)
  setlayout g,x+w,y+h,grp
  return g
endfunction

const event_dropfile%=$4010
const event_dropdir%=$4011

function createwin:twin(name$,x%,y%,w%,h%,style%=15,grp:tgadget=null)
  local g:twin=new twin
  g.name=name
  g.x=x
  g.y=y
  g.w=w
  g.h=h
  g.maxsize
  g.outside
  g.hidden=(style&window_hidden>0)
  g.g=createwindow(name,x,y,w,h,grp,style)
  if not(style&window_hidden) or (actwin=null) then actwin=g
'  g.client=(style&window_clientcoords<>0)
  g.cw=clientwidth (g.g)
  g.ch=clientheight(g.g)
'  g.cw=gadgetwidth (g.g)
'  g.ch=gadgetheight(g.g)
  return g
endfunction

type twin
  field g:tgadget
  field kid:tgadget=null
  field name$
  field x%,y%,w%,h%
  field cw%,ch%
  field dx%,dy%
  field hidden%',client%',maximized%
  field drop$,droptyp%

  method load(f:tstream,dat%=false)
    x=readpint(f)
    y=readpint(f)
    w=readpint(f)
    h=readpint(f)
'    client=readbyte(f)
    maxsize
    outside
    if not dat then return
    name=readstr(f)
    setgadgettext g,name
  endmethod
  method save(f:tstream,dat%=false)
    writepint f,x
    writepint f,y
    writepint f,w
    writepint f,h
'    writebyte f,client
    if not dat then return
    writestr f,name
  endmethod

  method reset()
'    if client then setgadgetshape g,x+cclientwidth,y+cclientheight,w-cclientwidth,h-cclientheight..
'              else setgadgetshape g,x,y,w,h
    setgadgetshape g,x,y,w,h
    cw=clientwidth (g)
    ch=clientheight(g)
  endmethod

  method activate()
    if (kid=null) then activategadget g else activategadget kid
  endmethod

  method show()
    hidden=0
    showgadget g
    if (kid<>null) then activategadget kid
'    pollsystem
  endmethod
  method hide()
    hidden=1
    hidegadget g
    pollsystem
  endmethod

  method center()
    x=desk[0]+(desk[2]-w)/2
    y=desk[1]+(desk[3]-h)/2
  endmethod

  method maxsize()
    if (w>desk[2]) then w=desk[2]
    if (h>desk[3]) then h=desk[3]
  endmethod

  method outside()
    if (x+w<desk[0]+16) then x=desk[0]+16-w
    if (x>desk[2]-16)   then x=desk[2]-16
    if (y<desk[1]-10)   then y=desk[1]-10
    if (y>desk[3]-20)   then y=desk[3]-20
  endmethod

  method upd%() 'return currentevent.id
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_windowmove
      dx=currentevent.x-x
      dy=currentevent.y-y
      x=currentevent.x
      y=currentevent.y
      cw=clientwidth (g)
      ch=clientheight(g)
    case event_windowsize
      w=currentevent.x
      h=currentevent.y
      cw=clientwidth (g)
      ch=clientheight(g)
    case event_windowactivate
      actwin=self
'      if (kid<>null) then activategadget kid
    case event_windowaccept
      drop=string(currentevent.extra)
      droptyp=filetype(drop)
      if (droptyp=filetype_file) then
        drop=delast(drop)
        return event_dropfile
      endif
      return event_dropdir
    endselect
    return currentevent.id
  endmethod
endtype

'-----------------------------------------

function createtab:ttab(x%,y%,w%,h%,grp:tgadget)
  local t:ttab=new ttab
  t.g=createtabber(x,y,w,h,grp)
  setlayout t.g,x+w,y+h,grp
  t.cw=clientwidth (t.g)
  t.ch=clientheight(t.g)
  return t
endfunction

type ttab
  field g:tgadget
  field t:tgadget[][]
  field cw%,ch%
  field on%,last%=-1,count%

  method load(f:tstream)
    activate min(readbyte(f),count-1)
  endmethod
  method save(f:tstream)
    writebyte f,on
  endmethod

  method activate(nr%=-1)
    last=on
    if (nr>=0) then if (nr>=t.length) then on=t.length-1 else on=nr
    for local a1%=0 until t.length
      for local a2%=0 until t[a1].length
        if (t[a1][a2]<>null) then hidegadget t[a1][a2]
      next
    next
    for local a2%=0 until t[on].length
      if (t[on][a2]<>null) then showgadget t[on][a2]
    next
    selectgadgetitem g,on
    if (t[on].length>0) then activategadget t[on][0]
  endmethod

  method add(text$,tip$="")
    addgadgetitem g,text,,,tip
    count:+1
    t=t[..count]
  endmethod

  method addkid(tab%,kid:tgadget)
    if not(kid=null) then hidegadget kid
    t[tab]=t[tab][..t[tab].length+1]
    t[tab][t[tab].length-1]=kid
  endmethod

  method upd%() 'return 1
    if (currentevent.source<>g)..
    or (currentevent.id<>event_gadgetaction) then return 0
    activate currentevent.data
    return 1
  endmethod
endtype

'-----------------------------------------

type tbut
  field g:tgadget[]
  field flag%[] 'bit0=checkbox bit1=disabled bit2>=tag

  method load(f:tstream)
    for local a%=0 until readpint(f)
      local flg%=readpint(f)
      for local b%=0 until g.length
        if (flg shr 2=flag[b] shr 2) then setbuttonstate g[b],flg&1
      next
    next
  endmethod
  method save(f:tstream)
    local l%
    for local a%=0 until g.length
      if (flag[a]&1) then l:+1
    next
    writepint f,l
    for local a%=0 until g.length
      if (flag[a]&1) then writepint f,buttonstate(g[a])+(flag[a]&$fffffffc)
    next
  endmethod

  method setstate(tg%,disable%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        flag[a]=(flag[a]&~2)+disable shl 1
        if disable then disablegadget g[a] else enablegadget g[a]
        return
      endif
    next
  endmethod

  method add(label$,tg%,x%,y%,w%,h%,grp:tgadget,sel%=0,style%=button_push,disable%=false)
    g=g[..g.length+1]
    g[g.length-1]=createbutton(label,x,y,w,h,grp,style)
    setlayout g[g.length-1],x+w,y+h,grp
    if sel then setbuttonstate g[g.length-1],1
    flag=flag[..flag.length+1]
    flag[flag.length-1]=((style=button_checkbox) or (style=button_radio))+(disable shl 1)+(tg shl 2)
    if disable then disablegadget g[g.length-1]
  endmethod

  method setname(tg%,name$)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then setgadgettext g[a],name
    next
  endmethod

  method get%(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then return buttonstate(g[a])
    next
  endmethod
  method set(tg%,sel%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        setbuttonstate g[a],sel
        return
      endif
    next
  endmethod

  method find%(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then return a
    next
  endmethod

  method upd%() 'return tag
    if (currentevent.id<>event_gadgetaction) then return 0
    for local a%=0 until g.length
      if (currentevent.source=g[a]) then return flag[a] shr 2
    next
  endmethod
endtype

'-----------------------------------------

function createtext:ttext(x%,y%,w%,h%,grp:tgadget,style%=0)
  local t:ttext=new ttext
  t.flag=(style=textarea_readonly) shl 1
  t.g=createtextarea(x,y,w,h,grp,style)
  setlayout t.g,x+w,y+h,grp
  setgadgetfilter t.g,textfilter
  settextareacolor t.g,0,0,0,true
'  settextareacolor t.g,255,255,255,false
  formattextareatext t.g,255,255,25,0
  t.settabs 3
  return t
endfunction

function textfilter%(ev:tevent,context:object)
  select ev.id
  case event_keydown,event_keychar
    if (ev.mods&modifier_command) then return 1
    if not ev.mods or (ev.mods&modifier_shift) then
      select ev.data
      case key_left,key_right,key_down,key_up,key_pageup,key_pagedown..
      ,key_delete,key_backspace,key_home,key_end,key_esc,key_capslock return 1
      endselect
    endif
    if (ev.mods&(modifier_shift)) then
      select ev.data
      case key_insert  return 1
      endselect
    endif
  endselect
  postevent ev
endfunction

'select ttext.upd
'  case 1 tmenu.popup 0,win.g
'  case 2 ttext.updkey
type ttext
  field g:tgadget
  field tab%,flag% '$1=linesafe $2=readonly $4=insertmode
  field chars%,lines%
  field char%,line%,linestart%,lineend%,inline%
  field selchars%,sellines%

  method load(f:tstream,data%=false)
    tab=readbyte(f)
    flag=readbyte(f)
    if not data then return
    settextareatext g,readstr(f)
    updpos
  endmethod
  method save(f:tstream,data%=false)
    writebyte f,tab
    writebyte f,flag
    if not data then return
    writestr f,textareatext(g)
  endmethod

  method settabs(sz%)
    tab=sz
    settextareatabs g,sz
  endmethod

  method getline$(l%=-1)
    if l<0 then l=line
    return delast(textareatext(g,l,1,textarea_lines),10)
  endmethod
  method insline(t$,l%=-1)
    if l<0 then l=line
    settextareatext g,addslash(t,10),l,0,textarea_lines
    updpos
  endmethod
  method delline(l%=-1,complete%=true)
    if (l<0) then l=line
    local c%=textareachar(g,l)
    settextareatext g,"",c,textareachar(g,l+1)-c-1+complete
    updpos
  endmethod

  method set(t$)
    settextareatext g,t
    updpos
  endmethod

  method add(t$,col%[])
    addtextareatext g,t
    formattextareatext g,col[0],col[1],col[2],0,textarealen(g)-t.length,t.length
    updpos
  endmethod

  method updpos()
    local olines%=lines+(lines=0),oline%=line
    local a%
    repeat
      chars=textarealen(g)
      lines=textarealen(g,textarea_lines)-(chars=0)

      char=textareacursor(g)
      line=textareacursor(g,textarea_lines)
      linestart=textareachar(g,line)
      lineend=textareachar(g,line+1)'-(line<lines-1)
      inline=char-linestart

      selchars=textareasellen(g)
'      sellines=textareasellen(g,textarea_lines)-(inline<>0)*(selchars=0)
      sellines=textarealine(g,char+selchars)-line

      if not(flag&$1) or (lines=olines) or a then return
      a:+1
      locktextarea g
      if lines>olines then
        if flag&$4 then
'          settextareatext g,"",textareachar(g,oline+1)-(oline=olines-1),textareachar(g,oline+1+lines-olines)-textareachar(g,oline+1)+(oline=olines-1)
          local lo%=lines-olines
          local olo%=oline+lo
          settextareatext g,"",textareachar(g,olo),textareachar(g,olo+lo)-textareachar(g,olo)
          settextareatext g,"",textareachar(g,olines)-(olines<textarealen(g,textarea_lines))
        else
          settextareatext g,"",textareachar(g,olines)-1..
        endif
      else
        addtextareatext g,charmul(chr(10),olines-lines)
      endif
rem not working
      if lines>olines then
        settextareatext g,"",textareachar(g,oline+1),textareachar(g,lines-olines+oline+1)-textareachar(g,oline+1)..
        for local a%=lines-olines-1 to 0 step-1
          settextareatext g,"",textareachar(g,oline+1+a)-1,1
        next
      else
        addtextareatext g,charmul(chr(10),olines-lines)
      endif
rem
endrem

      unlocktextarea g
      selecttextareatext g,char,0
    forever
  endmethod

  method upd%() 'return 1=gadgetmenu, 2=active
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_gadgetmenu  return 1
    case event_gadgetselect  updpos
    endselect
    return 2
  endmethod

  method updkey()
    select currentevent.id
    case event_keydown
      select currentevent.data
      case key_insert  flag=swapbit(flag,$4)
      endselect

    case event_keychar
      settextareatext g,chr(currentevent.data),char,selchars+(flag&$4<>0)
      selecttextareatext g,char+1,0
      updpos
    endselect
  endmethod
endtype

'-----------------------------------------

function createfield:tfield(text$,x%,y%,w%,h%,grp:tgadget,style%=0)
  local f:tfield=new tfield
  f.g=createtextfield(x,y,w,h,grp,style&1)
  setgadgetcolor f.g,0,0,0
  setgadgettextcolor f.g,255,255,255
  setlayout f.g,x+w,y+h,grp
  setgadgettext f.g,text
  f.state=(style&2) shr 1
  if f.state then disablegadget f.g
  return f
endfunction

type tfield
  field g:tgadget
  field state% '$1=disabled

  method load(f:tstream)
    setgadgettext g,readstr(f)
  endmethod
  method save(f:tstream)
    writestr f,textfieldtext(g)
  endmethod

  method setstate(disable%)
    state=disable
    if disable then disablegadget g else enablegadget g
  endmethod

  method get$()
    return textfieldtext(g)
  endmethod
  method set(s$)
    setgadgettext g,s
  endmethod

  method upd%()
    if (currentevent.id<>event_gadgetaction)..
    or (currentevent.source<>g) then return 0
    return 1
  endmethod
endtype

'-----------------------------------------
